
;CodeVisionAVR C Compiler V2.03.9 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATtiny13
;Clock frequency        : 4.800000 MHz
;Memory model           : Tiny
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 16 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;global const stored in FLASH  : Yes
;8 bit enums            : Yes
;Smart register allocation : Off
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny13
	#pragma AVRPART MEMORY PROG_FLASH 1024
	#pragma AVRPART MEMORY EEPROM 64
	#pragma AVRPART MEMORY INT_SRAM SIZE 64
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E

	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_phrase:
	.DB  0x43,0x51,0x20,0x43,0x51,0x20,0x44,0x45
	.DB  0x20,0x42,0x45,0x41,0x43,0x4F,0x4E,0x20
	.DB  0x31,0x2F,0x32,0x57,0x20,0x46,0x52,0x4F
	.DB  0x4D,0x20,0x53,0x50,0x42,0x20,0x52,0x55
	.DB  0x20,0x36,0x30,0x4E,0x20,0x33,0x30,0x45
	.DB  0x20,0x53,0x45,0x4E,0x44,0x20,0x52,0x45
	.DB  0x50,0x4F,0x52,0x54,0x53,0x20,0x54,0x4F
	.DB  0x20,0x42,0x45,0x41,0x43,0x4F,0x4E,0x53
	.DB  0x50,0x42,0x20,0x20,0x47,0x4D,0x41,0x49
	.DB  0x4C,0x20,0x43,0x4F,0x4D,0x2E,0x0
_symbols:
	.DB  0x1,0x0,0x0,0x1,0x0,0x1,0x1,0x1
	.DB  0x1,0x1,0x0,0x1,0x1,0x1,0x1,0x0
	.DB  0x0,0x1,0x1,0x1,0x0,0x0,0x0,0x1
	.DB  0x1,0x0,0x0,0x0,0x0,0x1,0x0,0x0
	.DB  0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0
	.DB  0x1,0x1,0x0,0x0,0x0,0x1,0x1,0x1
	.DB  0x0,0x0,0x1,0x1,0x1,0x1,0x0,0x2
	.DB  0x2,0x2,0x5,0x5,0x2,0x2,0x2,0x5
	.DB  0x5,0x2,0x2,0x2,0x5,0x5,0x2,0x2
	.DB  0x2,0x5,0x5,0x2,0x2,0x2,0x5,0x5
	.DB  0x2,0x2,0x2,0x5,0x5,0x2,0x2,0x2
	.DB  0x5,0x5,0x0,0x1,0x5,0x5,0x5,0x1
	.DB  0x0,0x0,0x0,0x5,0x1,0x0,0x1,0x0
	.DB  0x5,0x1,0x0,0x0,0x5,0x5,0x0,0x5
	.DB  0x5,0x5,0x5,0x0,0x0,0x1,0x0,0x5
	.DB  0x1,0x1,0x0,0x5,0x5,0x0,0x0,0x0
	.DB  0x0,0x5,0x0,0x0,0x5,0x5,0x5,0x0
	.DB  0x1,0x1,0x1,0x5,0x1,0x0,0x1,0x5
	.DB  0x5,0x0,0x1,0x0,0x0,0x5,0x1,0x1
	.DB  0x5,0x5,0x5,0x1,0x0,0x5,0x5,0x5
	.DB  0x1,0x1,0x1,0x5,0x5,0x0,0x1,0x1
	.DB  0x0,0x5,0x1,0x1,0x0,0x1,0x5,0x0
	.DB  0x1,0x0,0x5,0x5,0x0,0x0,0x0,0x5
	.DB  0x5,0x1,0x5,0x5,0x5,0x5,0x0,0x0
	.DB  0x1,0x5,0x5,0x0,0x0,0x0,0x1,0x5
	.DB  0x0,0x1,0x1,0x5,0x5,0x1,0x0,0x0
	.DB  0x1,0x5,0x1,0x0,0x1,0x1,0x5,0x1
	.DB  0x1,0x0,0x0,0x5

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x40)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x9F)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x70)
	LDI  R29,HIGH(0x70)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x70

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V1.25.3 Standard
;Automatic Program Generator
; Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 07.11.2011
;Author  : Dmitry Eljuseev, RA1AHC. dmitryelj@gmail.com
;
;
;Chip type           : ATtiny13
;Clock frequency     : 9,600000 MHz
;Memory model        : Tiny
;External SRAM size  : 0
;Data Stack size     : 16
;*****************************************************/
;
;#include <tiny13.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;// Port out:
;#define POUT   0
;// Port audio (do not change! hardware pwm)
;#define PAUDIO 1
;// Port LED:
;#define PLED   2
;
;#define REPEAT 3
;
;// Morze length
;#define L_DOT    80
;#define L_LINE   3*L_DOT
;#define S_PAUSE  L_DOT
;#define C_PAUSE  3*L_DOT
;
;#define TONE_ON    TCCR0A=0x23
;#define TONE_OFF   TCCR0A=0x03
;
;const unsigned char phrase[] = "CQ CQ DE BEACON 1/2W FROM SPB RU 60N 30E SEND REPORTS TO BEACONSPB  GMAIL COM.";
;
;#define REPEAT_DL 12000
;
;// Declare your global variables here
;// 0 - "."
;// 1 - "-"
;// 2 - pause
;// 3 - long pause
;// 5 - null
;#define SYM_LEN 5
;#define mA 0,1,5,5,5
;#define mB 1,0,0,0,5
;#define mC 1,0,1,0,5
;#define mD 1,0,0,5,5
;#define mE 0,5,5,5,5
;#define mF 0,0,1,0,5
;#define mG 1,1,0,5,5
;#define mH 0,0,0,0,5
;#define mI 0,0,5,5,5
;#define mJ 0,1,1,1,5
;#define mK 1,0,1,5,5
;#define mL 0,1,0,0,5
;#define mM 1,1,5,5,5
;#define mN 1,0,5,5,5
;#define mO 1,1,1,5,5
;#define mP 0,1,1,0,5
;#define mQ 1,1,0,1,5
;#define mR 0,1,0,5,5
;#define mS 0,0,0,5,5
;#define mT 1,5,5,5,5
;#define mU 0,0,1,5,5
;#define mV 0,0,0,1,5
;#define mW 0,1,1,5,5
;#define mX 1,0,0,1,5
;#define mY 1,0,1,1,5
;#define mZ 1,1,0,0,5
;#define m0 1,1,1,1,1
;#define m1 0,1,1,1,1
;#define m2 0,0,1,1,1
;#define m3 0,0,0,1,1
;#define m4 0,0,0,0,1
;#define m5 0,0,0,0,0
;#define m6 1,0,0,0,0
;#define m7 1,1,0,0,0
;#define m8 1,1,1,0,0
;#define m9 1,1,1,1,0
;#define m_ 2,2,2,5,5
;#define mSl 1,0,0,1,0
;
;const unsigned char symbols[] = {
;                                        mSl, m0, m1, m2, m3, m4, m5, m6, m7, m8, m9,    // '/',0,1-9
;                                        m_, m_, m_, m_, m_, m_, m_,                     // :;<=>?@
;                                        mA, mB, mC, mD, mE, mF, mG, mH, mI, mJ, mK, mL, mM, mN, mO, mP, mQ, mR, mS, mT, mU, mV, mW, mX, mY, mZ
;                                };
;
;void morze_out(flash unsigned char *pData)
; 0000 0063 {

	.CSEG
_morze_out:
; 0000 0064         unsigned char p, p1;
; 0000 0065         for(p=0; p<128; p++)
	RCALL __SAVELOCR2
;	*pData -> Y+2
;	p -> R16
;	p1 -> R17
	LDI  R16,LOW(0)
_0x4:
	CPI  R16,128
	BRLO PC+2
	RJMP _0x5
; 0000 0066         {
; 0000 0067                 unsigned char symb = pData[p];
; 0000 0068                 if (symb == '.') break;
	SBIW R28,1
;	*pData -> Y+3
;	symb -> Y+0
	MOV  R30,R16
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x2
	ST   Y,R30
	LD   R26,Y
	CPI  R26,LOW(0x2E)
	BRNE _0x6
	ADIW R28,1
	RJMP _0x5
; 0000 0069                 if (symb == '*') //  1 
_0x6:
	LD   R26,Y
	CPI  R26,LOW(0x2A)
	BRNE _0x7
; 0000 006A                 {
; 0000 006B                     PORTB.POUT = 1;
	RCALL SUBOPT_0x3
; 0000 006C                     TONE_ON;
; 0000 006D                     delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x4
; 0000 006E                     PORTB.POUT = 0;
	RCALL SUBOPT_0x5
; 0000 006F                     TONE_OFF;
; 0000 0070                     delay_ms(S_PAUSE);
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	RCALL SUBOPT_0x4
; 0000 0071                     continue;
	RJMP _0x2C
; 0000 0072                 }
; 0000 0073 
; 0000 0074                 if (symb == ' ') symb = '='; //      
_0x7:
	LD   R26,Y
	CPI  R26,LOW(0x20)
	BRNE _0xC
	LDI  R30,LOW(61)
	ST   Y,R30
; 0000 0075                 if (symb >= '/' && symb <= 'Z')
_0xC:
	LD   R26,Y
	CPI  R26,LOW(0x2F)
	BRLO _0xE
	CPI  R26,LOW(0x5B)
	BRLO _0xF
_0xE:
	RJMP _0xD
_0xF:
; 0000 0076                 {
; 0000 0077                         unsigned int symb_code  = symb - '/';
; 0000 0078                         unsigned int symb_index = SYM_LEN*symb_code;
; 0000 0079                         if (symb_index >= sizeof(symbols)) continue;
	SBIW R28,4
;	*pData -> Y+7
;	symb -> Y+4
;	symb_code -> Y+2
;	symb_index -> Y+0
	LDD  R30,Y+4
	SUBI R30,LOW(47)
	RCALL SUBOPT_0x0
	STD  Y+2,R30
	STD  Y+2+1,R31
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	RCALL __MULW12U
	ST   Y,R30
	STD  Y+1,R31
	RCALL SUBOPT_0x6
	CPI  R26,LOW(0xDC)
	LDI  R30,HIGH(0xDC)
	CPC  R27,R30
	BRLO _0x10
	ADIW R28,5
	RJMP _0x3
; 0000 007A 
; 0000 007B                         for(p1=0; p1<SYM_LEN; p1++)
_0x10:
	LDI  R17,LOW(0)
_0x12:
	CPI  R17,5
	BRSH _0x13
; 0000 007C                         {
; 0000 007D                                if (symbols[symb_index + p1] == 0) // "."
	RCALL SUBOPT_0x7
	CPI  R30,0
	BRNE _0x14
; 0000 007E                                {
; 0000 007F                                        PORTB.POUT = 1;
	RCALL SUBOPT_0x3
; 0000 0080                                        TONE_ON;
; 0000 0081                                        delay_ms(L_DOT);
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	RCALL SUBOPT_0x4
; 0000 0082                                        PORTB.POUT = 0;
	RCALL SUBOPT_0x5
; 0000 0083                                        TONE_OFF;
; 0000 0084                                        delay_ms(S_PAUSE);
	RJMP _0x2D
; 0000 0085                                } else
_0x14:
; 0000 0086                                if (symbols[symb_index + p1] == 1) // "-"
	RCALL SUBOPT_0x7
	CPI  R30,LOW(0x1)
	BRNE _0x1A
; 0000 0087                                {
; 0000 0088                                        PORTB.POUT = 1;
	RCALL SUBOPT_0x3
; 0000 0089                                        TONE_ON;
; 0000 008A                                        delay_ms(L_LINE);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	RCALL SUBOPT_0x4
; 0000 008B                                        PORTB.POUT = 0;
	RCALL SUBOPT_0x5
; 0000 008C                                        TONE_OFF;
; 0000 008D                                        delay_ms(S_PAUSE);
	RJMP _0x2D
; 0000 008E                                } else
_0x1A:
; 0000 008F                                if (symbols[symb_index + p1] == 2) // "pause"
	RCALL SUBOPT_0x7
	CPI  R30,LOW(0x2)
	BRNE _0x20
; 0000 0090                                {
; 0000 0091                                        delay_ms(S_PAUSE);
_0x2D:
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	RCALL SUBOPT_0x4
; 0000 0092                                }
; 0000 0093                         }
_0x20:
	SUBI R17,-1
	RJMP _0x12
_0x13:
; 0000 0094 
; 0000 0095                         delay_ms(C_PAUSE);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	RCALL SUBOPT_0x4
; 0000 0096                 }
	ADIW R28,4
; 0000 0097         }
_0xD:
_0x2C:
	ADIW R28,1
_0x3:
	SUBI R16,-1
	RJMP _0x4
_0x5:
; 0000 0098 }
	RCALL __LOADLOCR2
	ADIW R28,4
	RET
;
;void main(void)
; 0000 009B {
_main:
; 0000 009C         // Input/Output Ports initialization
; 0000 009D         // Port B initialization
; 0000 009E         // Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 009F         // State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 00A0         PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 00A1         DDRB=0x3F;
	LDI  R30,LOW(63)
	OUT  0x17,R30
; 0000 00A2 
; 0000 00A3         // Timer/Counter 0 initialization
; 0000 00A4         // Clock source: System Clock
; 0000 00A5         // Clock value: 75.000 kHz
; 0000 00A6         // Mode: Fast PWM top=FFh
; 0000 00A7         // OC0A output: Disconnected
; 0000 00A8         // OC0B output: Non-Inverted PWM
; 0000 00A9         TCCR0A=0x23;//0x03;
	LDI  R30,LOW(35)
	OUT  0x2F,R30
; 0000 00AA         TCCR0B=0x03;
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 00AB         TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 00AC         OCR0A=0x00;
	OUT  0x36,R30
; 0000 00AD         OCR0B=0x80;
	LDI  R30,LOW(128)
	OUT  0x29,R30
; 0000 00AE 
; 0000 00AF         // External Interrupt(s) initialization
; 0000 00B0         // INT0: Off
; 0000 00B1         // Interrupt on any change on pins PCINT0-5: Off
; 0000 00B2         GIMSK=0x00;
	LDI  R30,LOW(0)
	OUT  0x3B,R30
; 0000 00B3         MCUCR=0x00;
	OUT  0x35,R30
; 0000 00B4 
; 0000 00B5         // Timer/Counter 0 Interrupt(s) initialization
; 0000 00B6         TIMSK0=0x00;
	OUT  0x39,R30
; 0000 00B7 
; 0000 00B8         // Analog Comparator initialization
; 0000 00B9         // Analog Comparator: Off
; 0000 00BA         ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00BB         ADCSRB=0x00;
	LDI  R30,LOW(0)
	OUT  0x3,R30
; 0000 00BC 
; 0000 00BD         TONE_OFF;
	LDI  R30,LOW(3)
	OUT  0x2F,R30
; 0000 00BE 
; 0000 00BF         while (1)
_0x21:
; 0000 00C0         {
; 0000 00C1                 unsigned char p;
; 0000 00C2                 for(p=0; p<REPEAT; p++)
	SBIW R28,1
;	p -> Y+0
	LDI  R30,LOW(0)
	ST   Y,R30
_0x25:
	LD   R26,Y
	CPI  R26,LOW(0x3)
	BRSH _0x26
; 0000 00C3                 {
; 0000 00C4                         morze_out(phrase);
	LDI  R30,LOW(_phrase*2)
	LDI  R31,HIGH(_phrase*2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _morze_out
; 0000 00C5 
; 0000 00C6                         PORTB.PLED = 1;
	SBI  0x18,2
; 0000 00C7                         delay_ms(1500);
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	RCALL SUBOPT_0x4
; 0000 00C8                         PORTB.PLED = 0;
	CBI  0x18,2
; 0000 00C9                 }
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RJMP _0x25
_0x26:
; 0000 00CA 
; 0000 00CB                 delay_ms(REPEAT_DL);
	LDI  R30,LOW(12000)
	LDI  R31,HIGH(12000)
	RCALL SUBOPT_0x4
; 0000 00CC 
; 0000 00CD         };
	ADIW R28,1
	RJMP _0x21
; 0000 00CE }
_0x2B:
	RJMP _0x2B

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x0:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	LPM
	MOV  R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3:
	SBI  0x18,0
	LDI  R30,LOW(35)
	OUT  0x2F,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x4:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	CBI  0x18,0
	LDI  R30,LOW(3)
	OUT  0x2F,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	LD   R26,Y
	LDD  R27,Y+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x7:
	MOV  R30,R17
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	SUBI R30,LOW(-_symbols*2)
	SBCI R31,HIGH(-_symbols*2)
	RJMP SUBOPT_0x2


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x4B0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__MULW12U:
	MOV  R0,R26
	MOV  R1,R27
	LDI  R24,17
	CLR  R26
	SUB  R27,R27
	RJMP __MULW12U1
__MULW12U3:
	BRCC __MULW12U2
	ADD  R26,R0
	ADC  R27,R1
__MULW12U2:
	LSR  R27
	ROR  R26
__MULW12U1:
	ROR  R31
	ROR  R30
	DEC  R24
	BRNE __MULW12U3
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
